
import Queue
from time import sleep
from threading import Thread

class Worker(Thread):
    instance = None
    keepalive = 2.0

    def __init__(self, *items):
        super(Worker, self).__init__()
        self.queue = Queue.Queue()
        for item in items:
            self.queue.put(item)
        (items)
        self.daemon = True
        self.start()
            
    def run(self):
        while True:
            try:
                item = self.queue.get(self.keepalive)
            except Queue.Empty:
                break
            self.handle(item)
        print self.__class__.__name__, "died expectedly"
        self.queue = None
        
    @classmethod
    def push(cls, *items):
        # NB! Possible race-condition here
        try:
            for item in items:
                cls.instance.queue.put(item)
        except AttributeError:
            print "Spawning", cls.__name__
            cls.instance = cls(*items)
